#! /usr/bin/env python
from AIPS import AIPS
from AIPSTask import AIPSTask
from AIPSData import AIPSUVData
from AIPSData import AIPSImage

import os
import sys

AIPS.userno = 1999

task = AIPSTask('imagr')

args = sys.argv[1:]
outputs = []
tables = []
while args:
    if args[0] == 'outdata':
        s = args[1].split('_')
        data = AIPSImage(s[0], s[1], int(s[2]), 1)
        outputs.append((data, args[1]))
        task.outname = s[0]
        task.outseq = int(s[2])
        task.outdisk = 1
        if data.exists():
            data.zap()
            try:
                os.remove(args[1])
            except:
                pass
            pass
        args = args[2:]
        continue
    if args[0] == 'indata':
        s = args[1].split('_')
        data = AIPSUVData(s[0], s[1], int(s[2]), 1)
        if args[0] == 'indata':
            indata = data
        task.indata = data
        args = args[2:]
        continue
    if args[0] == 'sources':
        n = int(args[1])
        for i in xrange(n):
            task.sources[i + 1] = args[2]
            args = args[1:]
            continue
        args = args[2:]
        continue
    if args[0] == 'freqid':
        task.freqid = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'subarray':
        task.subarray = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'docalib':
        task.docalib = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'dopol':
        task.dopol = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'nchav':
        task.nchav = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'chinc':
        task.chinc = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'stokes':
        task.stokes = args[1]
        args = args[2:]
        continue
    if args[0] == 'uvwtfn':
        task.uvwtfn = args[1]
        args = args[2:]
        continue
    if args[0] == 'cellsize':
        n = int(args[1])
        for i in xrange(n):
            task.cellsize[i + 1] = float(args[2])
            args = args[1:]
            continue
        args = args[2:]
        continue
    if args[0] == 'imsize':
        n = int(args[1])
        for i in xrange(n):
            task.imsize[i + 1] = float(args[2])
            args = args[1:]
            continue
        args = args[2:]
        continue
    if args[0] == 'robust':
        task.robust = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'xtype':
        task.xtype = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'ytype':
        task.ytype = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'niter':
        task.niter = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'allokay':
        task.allokay = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'gain':
        task.gain = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'minpatch':
        task.minpatch = float(args[1])
        args = args[2:]
        continue
    if args[0] == 'imagrprm':
        n = int(args[1])
        for i in xrange(n):
            task.imagrprm[i + 1] = float(args[2])
            args = args[1:]
            continue
        args = args[2:]
        continue
    if args[0] == 'dotv':
        task.dotv = float(args[1])
        args = args[2:]
        continue
    print args
    raise Hell
    continue

task.go()

for output in outputs:
    if output[0].exists():
        fp = open(output[1], 'w')
        fp.close()
for table in tables:
    s = table.split('_')
    if [int(s[1]), 'AIPS %s' % s[0]] in indata.tables:
        open(table, 'a')
