from AIPS import AIPS
from AIPSTask import AIPSTask
from AIPSData import AIPSUVData

import gzip
import os
import urllib

AIPS.userno = 1999

# Download a smallish FITS file from the EVN archive.
url = 'http://archive.jive.nl/exp/N03L1_030225/fits/n03l1_1_1.IDI1'
file = '/tmp/' + os.path.basename(url)
if not os.path.isfile(file):
    urllib.urlretrieve(url, file)
assert(os.path.isfile(file))

name = os.path.basename(url).split('_')[0].upper()
uvdata = AIPSUVData(name, 'UVDATA', 1, 1)
if uvdata.exists():
    uvdata.zap()
    pass

assert(not uvdata.exists())

fitld = AIPSTask('fitld')
fitld.datain = file
fitld.outdata = uvdata
fitld.digicor = -1
fitld.go()

#assert(uvdata.exists())

# Download flagging file from the EVN archive.
url = 'http://archive.jive.nl/exp/N03L1_030225/pipe/n03l1.uvflg'
file = '/tmp/' + os.path.basename(url)
if not os.path.isfile(file):
    urllib.urlretrieve(url, file)
assert(os.path.isfile(file))

uvflg = AIPSTask('uvflg')
uvflg.indata = uvdata
uvflg.intext = file
uvflg.outfgver = 1
uvflg.go()

# Download flagging file from the EVN archive.
url = 'http://archive.jive.nl/exp/N03L1_030225/pipe/n03l1.chflag'
file = '/tmp/' + os.path.basename(url)
if not os.path.isfile(file):
    urllib.urlretrieve(url, file)
assert(os.path.isfile(file))

uvflg = AIPSTask('uvflg')
uvflg.indata = uvdata
uvflg.intext = file
uvflg.outfgver = 1
uvflg.go()

prtab = AIPSTask('prtab')
prtab.indata = uvdata
#prtab.inext = 'FG'
#prtab.invers = 1
prtab.intable = uvdata.table('FG', 1)
prtab.outprint = '/tmp/fg.out'
prtab.go()

# Download flagging file from the EVN archive.
url = 'http://archive.jive.nl/exp/N03L1_030225/pipe/n03l1.antab.gz'
file = '/tmp/' + os.path.basename(url)
if not os.path.isfile(file):
    urllib.urlretrieve(url, file)
assert(os.path.isfile(file))

f_in = gzip.open(file, 'r')
file = os.path.splitext(file)[0]
f_out = open(file, 'w')
f_out.writelines(f_in)
f_out.close()
f_in.close()

antab = AIPSTask('antab')
antab.indata = uvdata
antab.calin = file
antab.tyver = 1
antab.gcver = 1
antab.offset = 0.3
antab.go()

apcal = AIPSTask('apcal')
apcal.indata = uvdata
apcal.freqid = 1
apcal.tyver = 1
apcal.gcver = 1
apcal.snver = 1
apcal.prtlev = 1
apcal.go()

clcal = AIPSTask('clcal')
clcal.indata = uvdata
clcal.subarray = 1
clcal.opcode = 'CALI'
clcal.gainver = 1
clcal.gainuse = 2
clcal.snver = 1
clcal.refant = uvdata.antennas.index('WB') + 1
clcal.interpol = 'SELF'
clcal.doblank = 1
clcal.dobtween = 1
clcal.samptype = 'BOX'
clcal.go()
