import "aips";

aipsfile n03l1 <"/tmp/n03l1_1_1.IDI1">;
aipsfile n03l1_uvflg <"/tmp/n03l1.uvflg">;
aipsfile n03l1_fgout <"/tmp/n03l1.fgout">;
aipsfile n03l1_antab <"/tmp/n03l1.antab">;

aipsdata uvdata <aips_mapper;name="N03L1", class="UVDATA", seq=1>;

aipstable fgtable <aips_mapper;name="FG", version=1>;
aipstable tytable <aips_mapper;name="TY", version=1>;
aipstable gctable <aips_mapper;name="GC", version=1>;
aipstable sntable <aips_mapper;name="SN", version=1>;
aipstable basecal <aips_mapper;name="CL", version=1>;
aipstable ampcal <aips_mapper;name="CL", version=2>;

uvdata = fitld(datain=n03l1, digicor=-1.0);
basecal = cltable(uvdata);

fgtable = uvflg(indata=uvdata, intext=n03l1_uvflg);

n03l1_fgout = prtab(indata=uvdata, intable=fgtable);

(tytable, gctable) = antab(indata=uvdata, calin=n03l1_antab, offset=0.3);

(sntable) = apcal(indata=uvdata, freqid=1.0, tyver=tytable, gcver=gctable, prtlev=1.0);

#float antennaidx[string];
#
#string antennas[];
#antennas = antennas(uvdata);
#foreach a, i in antennas {
#  antennaidx[a] = 1.0 + @toFloat(i);
#}
#
#float ant = antennaidx["WB"];

float ant = 2.0;

(ampcal) = clcal(indata=uvdata, subarray=1.0, opcode="CALI", gainver=basecal, snver=sntable, refant=ant, interpol="SELF", doblank=1.0, dobtween=1.0, samptype="BOX");