# Bojan Nikolic
"""
Description of CASA Tasks
"""


symb= { "ms" : "Measurement Set",
        "in" : "Input data",
        "inout" : "Input data which are modified",
        "out"  : "Output -- file will be created"}

# symb are attributes of each data-like parameter of each task.  Type:
# Dict ( Dict String [String] ).  Outputs with "prefix" label have
# multiple output files automatically generated with case with the
# prefix as given by the user

td= { "importvla" : { "archivefiles": ["in" ],
                      "vis" : ["out"] },
      "flagcmd" : { "vis" : ["inout"] },
      "flagdata": { "vis" : ["inout"] },
      "setjy"   : { "vis" : ["inout"] },
      "gaincal" : { "vis" : ["in"] ,
                    "caltable" : ["out"] } ,
      "fluxscale" : {"vis" : ["in"],
                     "caltable" : ["in"],
                     "fluxtable" : ["out"] },
      "applycal" : { "vis" : ["inout"],
                     "gaintable" : ["in"] },
      "blcal" : {"vis" : ["in"],
                 "caltable" : ["out"],
                 "gaintable" : ["in"]},
      "split" : {"vis" : ["in"],
                 "outputvis" : ["out"]},
      "clean" : {"vis" : ["in"],
                 "imagename" : ["out", "prefix"] }
}









