Background information & existing systems
=========================================

There are at least two basic types of existing applications/platforms
that should provide useful input into the design of the language for
data reductions: software build systems (like make) and dataflow
programming languages.

Software build systems are clear examples of automatic dependency
tracking and caching of intermediate results. They are however
characterised by handling well changing data (in that case the input
source files) but generally do not handle well situations when the
rules for making the files change. Since exploratory data reduction is
mostly about changing the rules and parameters of data reduction,
these software build tools are not by themselves useful for data
reduction.

Dataflow programming languages make more explicit the flow of data
between routines, allowing automatic dependency analysis and
consequently automatic parallelisation. They do not however generally
handle caching of intermediate results and thus the whole program is
always rerun regardless of any changes in it.

Neither of these concepts is directly applicable to the data reduction
interface but many useful concepts are introduced.

Shake
-----

Like Make, but more advanced

http://community.haskell.org/~ndm/downloads/paper-shake_before_building-10_sep_2012.pdf

PyDFlow
-------

Python based dataflow programming system. Good discussion of
write-once variables. Author now working on SWIFT/T.

http://people.cs.uchicago.edu/%7Etga/pubs/armstrong-masters-rev.pdf
https://github.com/timarmstrong/pydflow

SWIFT
-----

Good discussion of declaring external programs for use within the
language. Basic typing of parameters.

http://www.ci.uchicago.edu/swift/main/

SWIFT/T
-------

Similar to swift, but some in-process computation capabilities. Based
on an MPI library and "TURBINE" which is a TCL based system.

https://sites.google.com/site/exmcomputing/swift-t

See publications here:

https://sites.google.com/site/exmcomputing/pubs


CloudHaskell
------------

http://haskell-distributed.github.io/

Pegasus
-------

A "workflow management system" for scientific data reduction. 

http://pegasus.isi.edu/
