Initial design ideas
====================

Tasks
-----

Like in SWIFT, have ability to declare a task by specifying its (bulk
data) inputs, parameters, outputs and how to actually run the task.

Write-once variables
--------------------

Programatic analysis of what the script is supposed to do is made much
easier by only having "write-once" variables. The order in which
script is run is then defined only by the data dependencies.  

(Write-once variable really just enforce purely functional
programming? But look more normal to the average user?)

Parameter Typing
----------------

Having a typing mechanism for inputs and parameters of tasks may be
beneficial. For example, applycal could specify it needs UV data and a
calibration table in order to work.

Implementing a type system from scratch is a lot of work. Maybe start
without a type system and then lift into Haskell's type system later?

Underlying execution engine
---------------------------

Something like "Turbine" would be great since it integrates with PBS
and therefore is cluster friendly from the start (can integrate into
time accounting etc).

Smart restarts
--------------

By this mean, when a script is several times in a row, only the
computations that could actually have changed should be re-run.

With write-once variables the script can be analysed into a relatively
simple graph of datasets connected by operations. Deciding if a
dataset has changed is however not trivial. Can conservatively demand
that file is only unchanged if its predecessor graph is exactly
identical to what it was before. However this is not efficient as some
graph re-orderings (e.g., just renaming variables!) could lead to
identical results but would not have identical graphs. So for maximum
efficiency need to work out a graph equivalence function.

Caching intermediate results
----------------------------

One complicating factors is that many typical tasks in CASA (and also
AIPS?) both read from a file and modify its content. Need some clever
copy scheme if want to cache intermediate results. Could be free on
file-systems with block-level sharing. 

How to create the graph describing the processing
-------------------------------------------------

Can either:

- Analyse the script/program to determine the DAG

- Have an execution through an interpreter and build the DAG as you go
  along
  





