The problem
===========
Bojan Nikolic remarks (Message-ID <87a9lwvv4c.fsf_-_@mrao.cam.ac.uk>) that we need "a function which compares two lists of rules and returns everything that could have changed with respect to some output variable."

Slightly more formally: we have two dependency graphs.  We want to compare them to find the differences that affect a given node.  (I.e., changes on which that node depends.)   Dependency graphs are directed, acyclic graphs (DAGs), so what we want is an algorithm that compares two DAGs and produces a list of differences.

My first thought was simply to topologically sort both graphs and compare the resulting lists, but this is too simple-minded: you need to preserve the graph structure while doing the comparison.

Eder and Wiggisser[1] wrote "to the best of our knowledge ther is no algorithm which can easily be adapted to calculate the edit operations between two DAGs", and set out to remedy the lack.  It looks to be more or less what we want.


[1] "A DAG Comparison Algorithm and Its Application to Temporal Data Warehousing" by Johann Eder and Karl Wiggisser 
(http://www.isys.uni-klu.ac.at/PDF/2006-0253-EdWi.pdf)

[2] "Code for manipulating graphs in Haskell" http://cdsmith.wordpress.com/2009/04/20/code-for-manipulating-graphs-in-haskell/

Abstract Syntax Trees
=====================
(Stardate: 2013-10-02) 

In the course of writing a sketch for a dependency graph based on a fragment of a ParselTongue script, I found myself transcribing the fragment in the form of an abstract syntax tree (AST).  It occurred to me to wonder if anyone had studied diff-style algorithms for ASTs, rather than the more general DAG case we have been looking at up to now.

Of course, they have: there's a small literature round-up at <http://www.monperrus.net/martin/tree-differencing>, and there is presumably plenty more stuff out there.

Since we're intending to diff scripts exclusively, this prior art is exactly what we really need.