# Instead of running CASA tasks, just record what they'd have done

import networkx as nx
import collections

TG=nx.DiGraph()
casatasks={}

_tdict = { "importvla" : { "in" : "archivefiles",
                           "out" : "vis"},
           "flagcmd"   : { "in" : "vis",
                           "out" : "vis"},
           "flagdata" : { "in" : "vis",
                           "out" : "vis"} , 
           "setjy"     : { "in" : "vis",
                           "out" :"vis"},
           "gaincal"   : { "in" : "vis",
                           "out" : "caltable"}}

def uniquify(n):
    global TG
    return "%s-%i" % (n, TG.size())

def stubatask(tname):
    """
    Only works for keyword args
    """
    def fn(**kwargs):
        global TG
        inl=[(x,kwargs[x]) for x in  kwargs if (x in _tdict[tname]["in"])]
        print inl
        outl=[(x,kwargs[x]) for x in  kwargs if (x in _tdict[tname]["out"])]
        n=uniquify(tname)
        pars=[(x, kwargs[x]) for x in kwargs if ( not( x in _tdict[tname]["in"] or x in _tdict[tname]["out"]))]
        TG.add_node(n, task=tname, pars=pars)
        for x in inl:
            if type(x[1])==list:
                for xx in x[1]:
                    TG.add_edge(xx, n, par=x[0])
            else:
                TG.add_edge(x[1], n, par=x[0])
        # check for duplicates
        rl={}
        for (xn, x) in outl:
            if x in TG.nodes():
                rl[x]=uniquify(x)
        if len(rl) > 0:
            TG=nx.relabel_nodes(TG,rl)
        # Add outputs
        for (xn,x) in outl:
            TG.add_edge(n, x, outpar=xn)
    casatasks[tname]=globals()[tname]
    globals()[tname]=fn

if 1:
    stubatask("importvla")          
    stubatask("flagcmd")          
    stubatask("flagdata")          
    stubatask("setjy")          
    stubatask("gaincal")          

def vG():
    pos=nx.graphviz_layout(TG, prog='dot')
    nx.draw(TG,pos=pos)
    nx.draw_networkx_labels(TG, pos=pos)

def exG(g):
    "Execute a graph"
    def isinput(n):
        return len(nx.ancestors(g, n))==0
    def copyinput(n):
        ifn=os.path.join("/home/bnikolic/d/astrodata/", n)
        if os.path.isdir(n):
            shutil.copytree(ifn, ".")
        else:
            shutil.copy(ifn, ".")
    def delist(x):
        if len(x)==1:
            return x[0]
        else:
            return x
    for s in nx.topological_sort(g):
        if isinput(s):
            copyinput(s)
        else:
            n=TG.node[s]
            if "task" in n.keys() :
                tname=n["task"]
                inpkw={_tdict[tname]["in"] : delist([x[0] for x in g.in_edges(s)])  }
                if _tdict[tname]["out"] == _tdict[tname]["in"]:
                    print "Output same as input"
                    copyto=delist([x[1] for x in g.out_edges(s)])
                    outkw={}
                else:
                    outkw={_tdict[tname]["out"] : delist([x[1] for x in g.out_edges(s)]) }
                    copyto=None
                pars=inpkw.items() +outkw.items()
                pp=eval(n["pars"])
                print pp
                if len(pp) > 0:
                    pars=pars+pp
                print pars
                globals()[tname]( **dict(pars))
                if copyto:
                    shutil.copytree(delist([x[0] for x in g.in_edges(s)]), copyto)
                

            
        
        


