import Control.Monad
import Data.List as DL
import Data.Maybe
import qualified Data.Set as DS
import System.Environment

import DMSUtil
import ASTPlus
import StmNode
import Tree
import MyGraph
import TreeGraph
import FlowGraph
import MyGraph (getInt)
import ToyParser
import TopSort
import Domination


main = 
  do
    [fn1] <- getArgs 
    -- Block 1
    Right protoAST <- parseFile fn1
    let ast = enumerateTreeV $ promoteTree protoAST ()
        nodeMap = extractNodeMap ast
        intTree = stripNodes $ treeifyAST ast
        g1 = treeToGraph intTree
        (cfg1, inOutMap1, gSynMap1) = fromTreeGraph g1 nodeMap
    putStrLn $ "first tree\n" ++ (show ast)
    putStrLn $ "nodeMap\n" ++ (show nodeMap)
    putStrLn $ "intTree\n" ++ (show intTree)
    putStrLn $ "Graph1\n" ++ (show g1)
    putStrLn $ "CFG1\n" ++ (show cfg1)
    let d1 = iterateDomination cfg1
        idom = domTree cfg1
    putStrLn $ "nodeMap\n" ++ (show d1)        
    putStrLn $ "nodeMap\n" ++ (show nodeMap)
    putStrLn $ "d1\n" ++ (show d1)
    -- astonishingly, this might actually work!:
    putStrLn $ "idom\n" ++ (show idom)

