module TupleGraph (
  preds
  , succs
  , roots
  , invertLMap
  ) where

import Data.List as DL
import Data.Map as DM

roots g = 
  let parents = DL.nub $ DL.map fst g
      children = DL.nub $ DL.map snd g
  in parents DL.\\ children

preds g n = DL.map fst $ DL.filter (\t -> snd t==n) g

succs g n = DL.map snd $ DL.filter (\t -> fst t==n) g

-- Don't read the function; the type tells you what you need to know.
-- (It was hard to write; it *should* be hard to read.)
invertLMap :: Ord b => [(a, [b])] -> [(b, [a])]
invertLMap l =
  toList $ DL.foldl (\m_outer (k, vs) ->
                      DL.foldl (\m_inner v ->
                                 DM.insertWith (++) v [k] m_inner)
                      m_outer vs) empty l
