{-# LANGUAGE CPP, DeriveDataTypeable #-}
--
-- Draws on /home/bnikolic/d/repopub/language-java/Language/Java/Parser.hs
module Language.Recipe.AST where

import Data.Data

#define DERIVE deriving (Eq,Ord,Show,Typeable,Data)

data Literal
    = Int Integer
    | Float Double
    | Char Char
    | String String
    | Null
  DERIVE

type Argument = Exp

data FormalParam = FormalParam Type Ident
  DERIVE

data Exp =
  Lit Literal
  | ExpName Ident
  | FunCallExp Ident [Argument]
  DERIVE

data FunDefn =
  AppFunDefn [FormalParam] Ident [FormalParam] [Stmt]
  DERIVE
  
data Stmt = PythonCall String [Exp] |
            DeclAssign Type Ident Exp |
            FunCall Ident [Argument]
  DERIVE
            

  
data Type
    = PrimType PrimType
    | OpaqueType String 
  DERIVE

data TypeDef = OpaqueTypeDef String
  DERIVE

data TLevel = Stmt Stmt |
  TypeDef TypeDef |
  FunDef FunDefn 
    DERIVE            

data PrimType
    = BooleanT
    | IntT
    | StringT
    | FloatT
  DERIVE

data Ident = Ident String
  DERIVE






                
